/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include <stdio.h>
#include "HL_sci.h"
#include "HL_mibspi.h"
#include "HL_sys_core.h"
#include "HL_gio.h"
#include "HL_rti.h"
#include "HL_adc.h"
#include "Application_Types.h"
#include "math.h"
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
uint32 periodicSTPassCount=0;
uint32 periodicSTFailCount=0;
uint32 maintaskcount = 0;
uint32 rtiCOMPARE2_PER,rtiCOMPARE1_PER_NEW,old_FCORERRCNT;
uint32  g_PotReading = 468750;
button USER1 = NONE, USER2 = NONE;

uint32 lowlighttimerperiod[6] = {
        10240000,  /*for adc value below 50*/
        9216000,   /*for adc value 50  - 100*/
        8192000,   /*for adc value 100 - 150*/
        7168000,   /*for adc value 150 - 200*/
        6144000,   /*for adc value 200 - 250*/
        5120000    /*for adc value 250 - 300*/
};
uint32 highlighttimerperiod[6] = {
        4096000,  /*for adc value 300 - 935*/
        3481600,  /*for adc value 935 -1570*/
        2867200,  /*for adc value 1570-2205*/
        2252800,  /*for adc value 2205-2840*/
        1638400,  /*for adc value 2840-3475*/
        1024000   /*for adc value 3475-4096*/
};

extern void sciDisplayText(sciBASE_t *sci, uint8 *text, uint32 length);
extern uint32 Get_Temp_Sensor_data(void);
void sciDisplayData(sciBASE_t *sci, uint8 *text,uint32 length);

/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */

    volatile boolean retVal; /* For function return values */
    periodicSTPassCount = 0;
    periodicSTFailCount = 0;

    gioInit();
    adcInit();
    adcCalibration(adcREG1);
    rtiInit();
    sciInit();
    mibspiInit(); //use MibSPI3 for timing measurement!

 // 19200bps 8N2 configured by HALCoGen for SCI1
    sciDisplayText(sciREG1,(uint8*)"------------------------------------------------------------------------------------------------------\r\n",104);
    sciDisplayText(sciREG1,(uint8*)"                                 Welcome to the Hercules Launchpad demo                               \r\n",104);
    sciDisplayText(sciREG1,(uint8*)"------------------------------------------------------------------------------------------------------\r\n",104);
    sciDisplayText(sciREG1,(uint8*)"1> Poti Demo: USER LED B (LED3) blinking frequency is controlled by the Poti. \r\n",82);
    sciDisplayText(sciREG1,(uint8*)"2> Button A: doubles LED2 blinking frequency.                                                         \r\n",104);
    sciDisplayText(sciREG1,(uint8*)"3> Button B: One time transfer of 4 TGs of MibSPI3 data.                                              \r\n",104);
    sciDisplayText(sciREG1,(uint8*)"------------------------------------------------------------------------------------------------------\r\n",104);


    /* Enable RTI Compare 0,1,2 interrupt notification */
    /*rtiCOMPARE0 used for detecting push button press*/
    rtiEnableNotification(rtiREG1,rtiNOTIFICATION_COMPARE0);
    /*rtiCOMPARE1 used for blinking LED2*/
    rtiEnableNotification(rtiREG1,rtiNOTIFICATION_COMPARE1);
    /*rtiCOMPARE1 used for blinking LED3*/
    rtiEnableNotification(rtiREG1,rtiNOTIFICATION_COMPARE2);
    /*rtiCOMPARE1 used for updating current temperature*/
    rtiEnableNotification(rtiREG1,rtiNOTIFICATION_COMPARE3);
    /* Enable IRQ - Clear I flag in CPS register */
    /* Note: This is usually done by the OS or in an svc dispatcher */
    _enable_IRQ();
    /* the current periods fo the COMPARE1 and COMPARE2*/
    rtiCOMPARE2_PER = rtiGetPeriod(rtiREG1,rtiCOMPARE2);
    rtiCOMPARE1_PER_NEW = rtiGetPeriod(rtiREG1,rtiCOMPARE1);
    /* Start RTI Counter Block 0 */
    rtiStartCounter(rtiREG1,rtiCOUNTER_BLOCK0);

    printf("Hello World!\n");


    while (1) {
        maintaskcount++;
        /*change the period of the ambient light balancing led LED3 based on the ambient light sensor input */
        /*as the light sensor input increases the speed of the blinking increases*/
        g_PotReading = Get_Temp_Sensor_data();
        rtiSetPeriod(rtiREG1,rtiCOMPARE2,1000*g_PotReading+468750);

        /*check whether switch USER1 has been pressed and do a flash ecc 1 bit selftest using diagnostic library*/
        if (SHORT_PRESS == USER1)
        {
            sciDisplayText(sciREG1,(uint8*)"Button A (User 1) pressed.  \r\n",30);
            rtiCOMPARE1_PER_NEW = rtiGetPeriod(rtiREG1,rtiCOMPARE1) / 2;
            rtiSetPeriod(rtiREG1,rtiCOMPARE1,rtiCOMPARE1_PER_NEW);

            USER1 = NONE;
        }
        if(SHORT_PRESS == USER2)
        {
            sciDisplayText(sciREG1,(uint8*)"Button B (User 2) pressed.  \r\n",30);
            sciDisplayText(sciREG1,(uint8*)"MibSPI3 Transfer!  \r\n",21);
            uint16 spidata[4*2] = {0x1111,0x2222,0x3333,0x4444,0x5555,0x6666,0x7777,0x8888};
            mibspiSetData(mibspiREG3, 0, &spidata[0*2]);
            mibspiSetData(mibspiREG3, 1, &spidata[1*2]);
            mibspiSetData(mibspiREG3, 2, &spidata[2*2]);
            mibspiSetData(mibspiREG3, 3, &spidata[3*2]);

            _disable_IRQ_interrupt_(); //prevent impact of interrupt requests on SPI CS timing

            //mibspiTransfer(mibspiREG3, 0);
            //mibspiTransfer(mibspiREG3, 1);
            //mibspiTransfer(mibspiREG3, 2);
            //mibspiTransfer(mibspiREG3, 3);
         // faster implementation of enabling one-shot transfers:
            mibspiREG3->TGCTRL[0] |= 0x80000000U;
            mibspiREG3->TGCTRL[1] |= 0x80000000U;
            mibspiREG3->TGCTRL[2] |= 0x80000000U;
            mibspiREG3->TGCTRL[3] |= 0x80000000U;
            _enable_IRQ_interrupt_();

            uint16 mydata;
            mibspiGetData(mibspiREG3, 0, &mydata); //makes no sense, no valid data received, no MISO connected

            USER2 = NONE;
        }
    }


/* USER CODE END */

    return 0;
}


/* USER CODE BEGIN (4) */
/* USER CODE END */
